----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    16:19:07 04/06/2010 
-- Design Name: 
-- Module Name:    EAU_ITER_TOP_c - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity EAU_ITER_TOP_c is
    Port ( rst : in  STD_LOGIC;
           clk : in  STD_LOGIC;
           valid_in : in  STD_LOGIC;
           value_in : in  STD_LOGIC_VECTOR (31 downto 0);
           valid_out : out  STD_LOGIC;
           vec_out : out  STD_LOGIC_VECTOR (11 downto 0);
           val_out : out  STD_LOGIC_VECTOR (31 downto 0));
end EAU_ITER_TOP_c;

architecture Behavioral of EAU_ITER_TOP_c is

component EAU_Iter_c is
    Port ( rst : in  STD_LOGIC;
           clk : in  STD_LOGIC;
           valid_in : in  STD_LOGIC;
           value_in : in  STD_LOGIC_VECTOR (24 downto 0);
           const_arg : in  STD_LOGIC_VECTOR (24 downto 0);
           valid_out : out  STD_LOGIC;
			  bit_out	: out STD_LOGIC;
           value_out : out  STD_LOGIC_VECTOR (24 downto 0));
end component;

constant const_val_iter1 : std_logic_Vector(8 downto 0):="001111110";-- 0000000000000000;--0.5
constant const_val_iter2 : std_logic_Vector(8 downto 0):="001111101";-- 0000000000000000;--0.25
constant const_val_iter3 : std_logic_Vector(8 downto 0):="001111100";-- 0000000000000000;--0.125
constant const_val_iter4 : std_logic_Vector(8 downto 0):="001111011";-- 0000000000000000;--0.0625
constant const_val_iter5 : std_logic_Vector(8 downto 0):="001111010";-- 0000000000000000;--0.03125
constant const_val_iter6 : std_logic_Vector(8 downto 0):="001111001";-- 0000000000000000;--0.015625
constant const_val_iter7 : std_logic_Vector(8 downto 0):="001111000";-- 0000000000000000;--0.0078125
constant const_val_iter8 : std_logic_Vector(8 downto 0):="001110111";-- 0000000000000000;--0.00390625
constant const_val_iter9 : std_logic_Vector(8 downto 0):="001110110";-- 0000000000000000;--0.001953125
constant const_val_iter10 : std_logic_Vector(8 downto 0):="001110101";-- 0000000000000000;--0.0009765625
constant const_val_iter11 : std_logic_Vector(8 downto 0):="001110100";-- 0000000000000000;--0.00048828125
constant const_val_iter12 : std_logic_Vector(8 downto 0):="001110011";-- 0000000000000000;--0.000244140625

signal iter1_vld_out: std_logic;

signal iter1_bit:	std_logic;

signal iter1_val_out: std_logic_vector(24 downto 0);

component FSM_CONTROL_TOP is
    Port ( rst : in  STD_LOGIC;
           clk : in  STD_LOGIC;
           vld_in : in  STD_LOGIC;
           sel_1_s : out  STD_LOGIC;
           sel_iter : out  STD_LOGIC_VECTOR (3 downto 0);
			  arg_id : out STD_LOGIC_VECTOR(3 downto 0);
			  vld_o : out STD_LOGIC);
end component;

signal valid_in_1c: std_logic;
signal arg_id: std_logic_vector(3 downto 0);
signal value_in_1c,const_val,iter_value_in_sel,iter1_val_out_reg: std_logic_vector(24 downto 0);

component MUX12to1_9to25 is
    Port ( sel : in  STD_LOGIC_VECTOR (3 downto 0);
           val1 : in  STD_LOGIC_VECTOR (8 downto 0);
           val2 : in  STD_LOGIC_VECTOR (8 downto 0);
           val3 : in  STD_LOGIC_VECTOR (8 downto 0);
           val4 : in  STD_LOGIC_VECTOR (8 downto 0);
           val5 : in  STD_LOGIC_VECTOR (8 downto 0);
           val6 : in  STD_LOGIC_VECTOR (8 downto 0);
           val7 : in  STD_LOGIC_VECTOR (8 downto 0);
           val8 : in  STD_LOGIC_VECTOR (8 downto 0);
           val9 : in  STD_LOGIC_VECTOR (8 downto 0);
           val10 : in  STD_LOGIC_VECTOR (8 downto 0);
           val11 : in  STD_LOGIC_VECTOR (8 downto 0);
           val12 : in  STD_LOGIC_VECTOR (8 downto 0);
           val_o : out  STD_LOGIC_VECTOR (24 downto 0));
end component;

signal sel_iter : std_logic_vector(3 downto 0);

component MUX2to1_25 is
    Port ( sel : in  STD_LOGIC;
           A : in  STD_LOGIC_VECTOR (24 downto 0);
           B : in  STD_LOGIC_VECTOR (24 downto 0);
           RES : out  STD_LOGIC_VECTOR (24 downto 0));
end component;

signal sel_1_s, iter_valid_in_sel,vld_o, iter1_vld_out_reg, iter1_bit_r: std_logic;

component LUT_ADDR_RF_TOP is
    Port ( clk : in  STD_LOGIC;
           iter_id : in  STD_LOGIC_VECTOR (3 downto 0);
           arg_id : in  STD_LOGIC_VECTOR (3 downto 0);
			  bitin : in STD_LOGIC;
           lut_addr_11 : out  STD_LOGIC_VECTOR (10 downto 0));
end component;

signal lut_addr_11_MSB: std_logic_Vector(10 downto 0);

begin

MUX_VAL: MUX2to1_25 Port Map
( 
  sel => sel_1_s,
  A => value_in_1c,
  B => iter1_val_out_reg,
  RES => iter_value_in_sel
);

iter_valid_in_sel<=((not sel_1_s) and valid_in_1c) or (sel_1_s and iter1_vld_out_reg);

ITER_COMP: EAU_Iter_c Port Map
( rst => rst,
  clk => clk,
  valid_in => iter_valid_in_sel,
  value_in => iter_value_in_sel,
  const_arg => const_val,
  valid_out => iter1_vld_out,
  bit_out	=> iter1_bit, -- MSB to LSB 
  value_out => iter1_val_out
);

MUX12to1_9to25_P: MUX12to1_9to25 Port Map
( sel => sel_iter,
  val1 => const_val_iter1,
  val2 => const_val_iter2,
  val3 => const_val_iter3,
  val4 => const_val_iter4,
  val5 => const_val_iter5,
  val6 => const_val_iter6,
  val7 => const_val_iter7,
  val8 => const_val_iter8,
  val9 => const_val_iter9,
  val10 => const_val_iter10,
  val11 => const_val_iter11,
  val12 => const_val_iter12,
  val_o => const_val
);

process(clk)
begin
if clk'event and clk='1' then
	valid_in_1c<=valid_in;
	value_in_1c<=value_in(31 downto 7);
	iter1_val_out_reg<=iter1_val_out;
	iter1_vld_out_reg<=iter1_vld_out;	
	iter1_bit_r <=iter1_bit;
end if;
end process;

FSM: FSM_CONTROL_TOP Port Map
( rst => rst,
  clk => clk,
  vld_in => valid_in,
  sel_1_s => sel_1_s,
  sel_iter => sel_iter,
  arg_id => arg_id,
  vld_o => vld_o
);  
  
LUT_ADDR_RF_TOP_C: LUT_ADDR_RF_TOP Port Map
( clk => clk,
  iter_id => sel_iter,
  arg_id => arg_id,
  bitin => iter1_bit_r,
  lut_addr_11 => lut_addr_11_MSB
);

vec_out(11 downto 1)<=lut_addr_11_MSB;
vec_out(0)<=iter1_bit;

valid_out<=iter1_vld_out and vld_o;
val_out(31 downto 7)<=iter1_val_out;
val_out(6 downto 0)<="0000000";

end Behavioral;

