----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    12:14:02 04/06/2010 
-- Design Name: 
-- Module Name:    EAU_PRE_ITER_c - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity EAU_PRE_ITER_c is
    Port ( rst : in  STD_LOGIC;
           clk : in  STD_LOGIC;
           vld_in : in  STD_LOGIC;
           fp_val_in : in  STD_LOGIC_VECTOR (31 downto 0);
			  int32_vld_out: out STD_LOGIC;
           int32_val_out : out  STD_LOGIC_VECTOR (31 downto 0);
			  fp_sub_vld_out: out STD_LOGIC;
           fp_sub_val_out : out  STD_LOGIC_VECTOR (31 downto 0));
end EAU_PRE_ITER_c;

architecture Behavioral of EAU_PRE_ITER_c is

component fpsp_2_int32 is
  port (
    rdy : out STD_LOGIC; 
    operation_nd : in STD_LOGIC := 'X'; 
    clk : in STD_LOGIC := 'X'; 
    a : in STD_LOGIC_VECTOR ( 31 downto 0 ); 
    result : out STD_LOGIC_VECTOR ( 31 downto 0 ) 
  );
end component;

signal rdy_conv1, rdy_conv2, op_nd_conv1, op_nd_conv2: std_logic;
signal t_int32_val_out, t_fpsp_val_out, fp_val_in_shftd : std_logic_vector(31 downto 0);

component int32_2_fpsp is
  port (
    rdy : out STD_LOGIC; 
    operation_nd : in STD_LOGIC := 'X'; 
    clk : in STD_LOGIC := 'X'; 
    a : in STD_LOGIC_VECTOR ( 31 downto 0 ); 
    result : out STD_LOGIC_VECTOR ( 31 downto 0 ) 
  );
end component;

component shift_reg_32b_12c is
  port (
    clk : in STD_LOGIC := 'X'; 
    d : in STD_LOGIC_VECTOR ( 31 downto 0 ); 
    q : out STD_LOGIC_VECTOR ( 31 downto 0 ) 
  );
end component;

component sp_fp_sub is
  port (
    rdy : out STD_LOGIC; 
    operation_nd : in STD_LOGIC := 'X'; 
    clk : in STD_LOGIC := 'X'; 
    a : in STD_LOGIC_VECTOR ( 31 downto 0 ); 
    b : in STD_LOGIC_VECTOR ( 31 downto 0 ); 
    result : out STD_LOGIC_VECTOR ( 31 downto 0 ) 
  );
end component;

signal op_nd_sub1,rdy_sub1: std_logic;
signal fp_val_in_rdcd,fp_val_in_subshftd: std_logic_Vector(31 downto 0);
constant const_val : std_logic_Vector(31 downto 0):="00111111000000000000000000000000";

component shift_reg_32b_11c is
  port (
    clk : in STD_LOGIC := 'X'; 
    d : in STD_LOGIC_VECTOR ( 31 downto 0 ); 
    q : out STD_LOGIC_VECTOR ( 31 downto 0 ) 
  );
end component;

begin

REDUCE_INPUT: sp_fp_sub Port Map
(
    rdy => rdy_sub1,
    operation_nd => vld_in,
    clk => clk, 
    a => fp_val_in, 
    b => const_val,
    result => fp_val_in_rdcd
);

op_nd_conv1<=rdy_sub1;

SHIFTER1: shift_reg_32b_11c Port Map  
(
    clk => clk,
    d => fp_val_in, 
    q => fp_val_in_subshftd
);

FPSP2INT32: fpsp_2_int32 Port Map
(
    rdy => rdy_conv1,
    operation_nd => op_nd_conv1, 
    clk => clk,
    a => fp_val_in_rdcd,
    result => t_int32_val_out
);

int32_vld_out<=rdy_conv1;
int32_val_out<=t_int32_val_out;

op_nd_conv2<=rdy_conv1;

INT322FPSP: int32_2_fpsp Port Map
(
    rdy => rdy_conv2, 
    operation_nd => op_nd_conv2, 
    clk => clk, 
    a => t_int32_val_out,
    result => t_fpsp_val_out 
);  
  
SHIFTER2: shift_reg_32b_12c Port Map  
(
    clk => clk,
    d => fp_val_in_subshftd, 
    q => fp_val_in_shftd
);
  
SUB: sp_fp_sub Port Map
(
    rdy => fp_sub_vld_out,
    operation_nd => rdy_conv2,
    clk => clk, 
    a => fp_val_in_shftd, 
    b => t_fpsp_val_out,
    result => fp_sub_val_out
);

end Behavioral;

