----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    11:20:05 05/04/2010 
-- Design Name: 
-- Module Name:    CONTROL_PRE_ITER_FSM - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity CONTROL_PRE_ITER_FSM is
    Port ( rst : in  STD_LOGIC;
           clk : in  STD_LOGIC;
           vld_in : in  STD_LOGIC;
           sel : out  STD_LOGIC;
           vld_out : out  STD_LOGIC);
end CONTROL_PRE_ITER_FSM;

architecture Behavioral of CONTROL_PRE_ITER_FSM is

TYPE state is (rst_st,
					idle_st,
					accom_in_st,
					forwrd_out_st);

signal cur_st,nxt_st: state;

component COUNTER_5b is
    Port ( rst : in  STD_LOGIC;
           clk : in  STD_LOGIC;
           en : in  STD_LOGIC;
           val : inout  STD_LOGIC_VECTOR (4 downto 0));
end component;

signal val_c,count_match: std_logic_Vector(4 downto 0);
signal en_c, rst_c, nxt: std_logic;

component comp_5b is
  port (
    qa_eq_b : out STD_LOGIC; 
    clk : in STD_LOGIC := 'X'; 
    a : in STD_LOGIC_VECTOR ( 4 downto 0 ); 
    b : in STD_LOGIC_VECTOR ( 4 downto 0 ) 
  );
end component;

begin

process(clk)
begin
if (rst='1') then
	cur_st<= rst_st;
elsif (clk'event and clk='1') then
	cur_st <= nxt_st;
end if;
end process;

process(cur_st,vld_in,nxt)
begin 
case cur_st is

when rst_st =>

	rst_c<='1';	
	en_c<='0';
	sel<='0';
	vld_out<='0';
	count_match<="00000";		  
	nxt_st<=idle_st;
	
when idle_st =>

	rst_c<='0';	
	sel<='0';
	vld_out<='0';
	count_match<="10101";	  

	if vld_in='1' then
		en_c<='1';
		nxt_st<=accom_in_st;
	else
		en_c<='0';
		nxt_st<=idle_st;
	end if;
	
when accom_in_st =>

		
	en_c<='1';
	sel<='0';
	vld_out<='0';
	count_match<="10101";
	
	if nxt='1' then
		rst_c<='1';	
		nxt_st<=forwrd_out_st;
	else
		rst_c<='0';
		nxt_st<=accom_in_st;
	end if;
	
	
when forwrd_out_st =>

	sel<='1';
	vld_out<='1';
	en_c<='1';
	count_match<="10101";
	
	if nxt='1' then
		rst_c<='1';	
		nxt_st<=idle_st;
	else	
		rst_c<='0';	
		nxt_st<=forwrd_out_st;
	end if;		

end case;
end process;

FSM_COUNT: COUNTER_5b Port Map
(  rst => rst_c,
   clk => clk,
   en => en_c,
   val => val_c
);

FSM_COMP: comp_5b Port Map
(  qa_eq_b => nxt,
	clk => clk, 
	a => val_c, 
	b => count_match 
);

end Behavioral;

